<?php
/**
 * PHP Demo page for Card Gate Gateway using class
 * (C)2014 Card Gate B.V.
 *
 * V1.0 (LH) - 2014-06-27
 */

require 'CardGate.class.php';

# Enter the correct Site info from https://merchants.cardgateplus.com/
$oCG = new CardGate( 1001, 'DEMO', TRUE );

# Check if callback args and hash
if( ! $oCG->checkCallback( $_REQUEST ) ) {
	die( "ERROR: " . $oCG->sLastError );
}

# Handle the transaction update here
try {

	switch( $_REQUEST['status'] ) {
		case   0: // Pending
			// Transaction is still being processed; can be delayed update from acquirer
			// UPDATE order SET status='pending', last_change=NOW() WHERE order_id=" . intval($_REQUEST['ref'])
			break;

		case 200: // Success
			// Update local order etc.
			// UPDATE order SET status='payed', payment_date=NOW() WHERE order_id=" . intval($_REQUEST['ref'])
			break;

		case 300: // Failure
			// Details about the failure are in status_id
			if( 305 == $_REQUEST['status_id'] ) {
				// User cancelled
				mail( 'to@the.user'
					, 'Order ' . $_REQUEST['ref'] . ' payment incomplete'
					, "Your payment for order {$_REQUEST['ref']} was not completed, please use the link below to complete the payment.\r\n"
					# Very quick and dirty way to retry transaction payment; will always use same payment method!
					. "<a href='{$oCG->getGatewayURL}?cgml{$_REQUEST['transactionid']}'>Complete Payment</a>"
					);
				break;
			}
		elseif( 308 == $_REQUEST['status_id'] ) {
				// Transaction was expired; usually because the user closed the payment page
				// Cancel the order in local system
				// UPDATE order SET status='cancelled' WHERE order_id=" . intval($_REQUEST['ref'])
			} else {
				// Technical failure of payment method or other errors
				// UPDATE order SET status='failure' WHERE order_id=" . intval($_REQUEST['ref'])
			}
			break;

		case 700:
		case 710:
			// Banktransfer or Direct Debit accepted; waiting for bank confirmation
			// UPDATE order SET status='processing' WHERE order_id=" . intval($_REQUEST['ref'])
			break;

		default:
			// Ignore other status-codes
			break;

	}
	# Return result to CG system showing we processed the request correctly
    exit( $_REQUEST['transaction_id'] . '.' . $_REQUEST['status'] );

} catch( Exception $e ) {
	# Return error message for CG system
	die( "ERROR processing request" );
}

// == End of callback_demo